PFBData (Apache FOP Core 2.11 API)
Date: 2025-04-24

org.apache.fop.fonts.type1

## Class PFBData

- java.lang.Object
- - org.apache.fop.fonts.type1.PFBData

-     public class PFBData
      extends Object

  Class that represents the contents of a PFB file.
  See Also:
    `PFBParser`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `PFB_MAC` MAC Format (unsupported, yet)
    `static int` | `PFB_PC` PC format
    `static int` | `PFB_RAW` Raw format, no special file structure

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PFBData()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte[]` | `getEncryptedSegment()` Gets the encrypted segment of the font file
    `byte[]` | `getHeaderSegment()` Gets the header segment of the font file
    `int` | `getLength()` Returns the full length of the raw font file.
    `int` | `getLength1()` Returns the Length1 (length of the header segment).
    `int` | `getLength2()` Returns the Length2 (length of the encrypted segment).
    `int` | `getLength3()` Returns the Length3 (length of the trailer segment).
    `int` | `getPFBFormat()` Returns the format the font was loaded with.
    `byte[]` | `getTrailerSegment()` Gets the trailer segment of the font file
    `void` | `outputAllParts(OutputStream out)` Writes the PFB file in raw format to an OutputStream.
    `void` | `setEncryptedSegment(byte[] encryptedSeg)` Sets the encrypted segment of the font file.
    `void` | `setHeaderSegment(byte[] headerSeg)` Sets the header segment of the font file.
    `void` | `setPFBFormat(int format)` Sets the PFB format the font was loaded with.
    `void` | `setTrailerSegment(byte[] trailerSeg)` Sets the trailer segment of the font file.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### PFB_RAW

          public static final int PFB_RAW

      Raw format, no special file structure
      See Also:
        Constant Field Values

    - #### PFB_PC

          public static final int PFB_PC

      PC format
      See Also:
        Constant Field Values

    - #### PFB_MAC

          public static final int PFB_MAC

      MAC Format (unsupported, yet)
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PFBData

          public PFBData()

  - ### Method Detail

    - #### setPFBFormat

          public void setPFBFormat(int format)

      Sets the PFB format the font was loaded with.
      Parameters:
        `format` - one of the PFB_* constants

    - #### getPFBFormat

          public int getPFBFormat()

      Returns the format the font was loaded with.
      Returns:
        int one of the PFB_* constants

    - #### setHeaderSegment

          public void setHeaderSegment(byte[] headerSeg)

      Sets the header segment of the font file.
      Parameters:
        `headerSeg` - the header segment

    - #### getHeaderSegment

          public byte[] getHeaderSegment()

      Gets the header segment of the font file
      Returns:
        Header segment as a byte array

    - #### setEncryptedSegment

          public void setEncryptedSegment(byte[] encryptedSeg)

      Sets the encrypted segment of the font file.
      Parameters:
        `encryptedSeg` - the encrypted segment

    - #### getEncryptedSegment

          public byte[] getEncryptedSegment()

      Gets the encrypted segment of the font file
      Returns:
        The encrypted segment as a byte array

    - #### setTrailerSegment

          public void setTrailerSegment(byte[] trailerSeg)

      Sets the trailer segment of the font file.
      Parameters:
        `trailerSeg` - the trailer segment

    - #### getTrailerSegment

          public byte[] getTrailerSegment()

      Gets the trailer segment of the font file
      Returns:
        The trailer segment as a byte array

    - #### getLength

          public int getLength()

      Returns the full length of the raw font file.
      Returns:
        int the raw file length

    - #### getLength1

          public int getLength1()

      Returns the Length1 (length of the header segment).
      Returns:
        int Length1

    - #### getLength2

          public int getLength2()

      Returns the Length2 (length of the encrypted segment).
      Returns:
        int Length2

    - #### getLength3

          public int getLength3()

      Returns the Length3 (length of the trailer segment).
      Returns:
        int Length3

    - #### outputAllParts

          public void outputAllParts(OutputStream out)
                              throws IOException

      Writes the PFB file in raw format to an OutputStream.
      Parameters:
        `out` - the OutputStream to write to
      Throws:
        `IOException` - In case of an I/O problem

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2025 Apache Software Foundation. All rights reserved.